/*
 * Project Name:
                        Nokia LCD 2 fili
                        Collegamento tra Nokia e PIC con soli 2 fili.
                        Interfaccia con 47HC595.
                        ATTENZIONE se il 74HC595 NON  HC potrebbe non funzionare.
                        Nel caso provare a variare il condensatore C1 da 100pF e
                        variare il tempo indicato nella funzione "void Send_str_595 ()"
 * Copyright:
                        JUMBO elettronica
                        jumboelettronica.altervista.org
                        jumboelettromania.altervista.org
                        jumboelettromania@gmail.com

  * Revision History:
                       27/11/2020:  Init
                       28/11/2020:  Testato con 74HC595 @ 3,3V e 5V. 4 fili.
                       29/11/2020.  Testato con 6 fili.

 * Test configuration:
     MCU:             PIC16F1825
     Scheme:
     Board:
     Oscillator:      INT+PLL, 32,000MHz
     Ext. Modules:    -
     SW:              mikroC pro

 * NOTES:
      GLCD: pin 1:  BOARD: +3,3V  (V.alimentazione)
            pin 2:         RC4    (SCK)
            pin 3:         RC5    (SDI)
            pin 4:         RC6    (D_C)
            pin 5:         GND    (SCE -> ENABLE)
            pin 6:         GND    (GND)
            pin 7:         1uF    (CONDENSATORE CON PIN - A MASSA)
            pin 8:         RC7    (RESET)

      INPUT ANALOGICO: RA2
      OUT PWM:         RC1
      INPUT INT:       RA0
      LED:             RC0

      Nokia GLCD bit ADC: sulla parte alta del display max. 151 bit
                          sulla parte bassa min.            104 bit

        CENTRALE UNIVERSALE 3B
// --- LED (OUTPUT)
 sbit LED_1 at LATA5_bit;   // OUT 1
 sbit LED_2 at LATC0_bit;   // OUT 2
 sbit LED_3 at LATB7_bit;   // OUT 3
 sbit LED_4 at LATB6_bit;   // OUT 4
 sbit LED_5 at LATB5_bit;   // OUT 5
 sbit LED_6 at LATC2_bit;   // OUT 6
// --- Pulsanti (INPUT)
 sbit pul_1 at RC6_bit;   // IN 1
 sbit pul_2 at RC7_bit;   // IN 2
 sbit pul_3 at RB4_bit;   // IN 3
 sbit pul_4 at RC1_bit;   // IN 4
 sbit pul_5 at RA3_bit;   // IN 5
*/
//
 #include  "Init_PIC16F182X.c"       // Inizializzazione CPU
 #include  "Nokia3310_Lib_2_Wire.c"
//
 sbit led2 at LATC0_bit;
 sbit led6 at LATC2_bit;
//
 sbit pul4 at RC1_bit;   // IN 4
 sbit pul5 at RA3_bit;   // IN 5
//
  const char jumbo[] = "JUMBO elettr.";
//
// *****************************************************************************
//
// ***************************************************************************** RITARDI
 void Delay_msec (unsigned int count_delay) {
//
      for (count_delay; count_delay > 0; count_delay --) {
         Delay_ms (1) ;
          asm {clrwdt}
      }
  }
// ***************************************************************************** INTERRUPT
//
// *****************************************************************************
 void interrupt () {
//
 }
// *****************************************************************************
//
// *****************************************************************************
 void main() {
  unsigned int temp_16=0;
//
      Init_PIC();             // Inizilizzazione micro
       Delay_msec(255);
        initlcd();           // Inizilizzazione GLCD
         clearram();
          Write_Bitmap(1);   Delay_msec(2000);  clearram();
           LED_LCD = 1;      // LED LCD Nokia ON
//
   while (1) {
//
        led2 ^= 1;
         Delay_msec(200);
          temp_16 ++;
 //
       Write_String ("JUMBO elettr.", 0, 5);
       Write_String ("Ciao, ciao", 0x81, 5);

       cursorxy(4, 3); putstr("By-By, Hallo!");

       cursorxy(4, 4); putstr(jumbo);

       Dec_BCD_Short (temp_16, 2, 10);
        Decimale_BCD (temp_16, 5, 20, 0x20);
//
   }
//
 }
/*














*/