/*
* Copyright:
                        JUMBO elettronica
                        jumboelettronica.altervista.org
                        jumboelettromania.altervista.org
                        jumboelettromania@gmail.com
                        
               LIBRERIA PER DISPLAY GLCD NOKIA 3310
              
  29/11/2020 - Soluzione che limita il numero di fili al PIC.
               La soluzione scelta, collega al positivo il RESET e il LED.
               Se si desidera controllare tali pin direttamente dal PIC,
               decomentare quanto definito sotto.

*/
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> DECOMENTARE IL COLLEGAMENTO SCELTO!!!
 #define Wire_4         // Aggiornamento pi veloce!
 //#define Wire_6
// --- Valido per reset e led collegati al 595!
 #ifdef Wire_6
 #define SDI value_lcd.B5
 #define SCK value_lcd.B4
 #define _SCE value_lcd.B3
 #define D_C value_lcd.B2
 #define _RST value_lcd.B1
 #define LED_LCD value_lcd.B0
 #define mark 6
 #endif
// --- Valido per reset e led NON collegati al 595! (pi veloce!)
 #ifdef Wire_4
 #define LED_LCD value_lcd.B5
 #define _RST value_lcd.B4
 #define SDI value_lcd.B3
 #define SCK value_lcd.B2
 #define _SCE value_lcd.B1
 #define D_C value_lcd.B0
 #define mark 4
 #endif
//
 sbit clk_595   at LATA4_bit;
 sbit data_595  at LATA5_bit;
// sbit store_595 at LATA2_bit;
//
 #include "bmp_1.h"
//
void Dec_BCD_Short (unsigned short, unsigned short, unsigned short, unsigned short);
void Decimale_BCD (unsigned int, unsigned short, unsigned short, unsigned short);
void Delay_2us ();
void Delay_msec (unsigned int);
void initlcd(void);               // Initializes the LCD.
void writecom(char);            // Writes a command.
void writedata(char);            // Writes data to DDRAM to illuminate the pixels.
void clockdata(char);            // Clocks in data into the PCD8544 controller.
void clearram(void);            // Erase the DDRAM contents.
void cursorxy(char,char);         // Position cursor to x,y.
void nokia_erase_y(char);
void nokia_erase_x(char);
void nokia_plot(char,char);
void nokia_write_data_inv(char);
void putchar(char);               // Write one character.
void putstr(const char *);         // Writes a string of characters.
void inicpu();
void Write_Bitmap();
void Draw_line_vert_KS0713(unsigned char, unsigned char, unsigned char, char);
//
 unsigned char const Byte_LOW [8] ={0b11111111,0b11111110,0b11111100,0b11111000,
                                    0b11110000,0b11100000,0b11000000,0b10000000};
 unsigned char const Byte_HIGH [8] ={0b00000001,0b00000011,0b00000111,0b00001111,
                                     0b00011111,0b00111111,0b01111111,0b11111111};
//
 char num_bit, value_lcd;


//
 const char table[480] = {                      // ASCII table for NOKIA LCD: 96 rows * 5 bytes= 480 bytes
                    0x00,0x00,0x00,0x00,0x00,  // 20 space
                     0x00,0x00,0x5f,0x00,0x00, // 21 !
                     0x00,0x07,0x00,0x07,0x00, // 22 "
                     0x14,0x7f,0x14,0x7f,0x14, // 23 #
                     0x24,0x2a,0x7f,0x2a,0x12, // 24 $
                     0x23,0x13,0x08,0x64,0x62, // 25 %
                     0x60,0x60,0x7F,0x03,0x03, // TRIGGER: FRONTE IN SALITA     //* & */
                     0x03,0x03,0x7F,0x60,0x60, // TRIGGER: FRONTE IN DISCESA    //* ' */  0x27
                     0x00,0x1c,0x22,0x41,0x00, // 28 (
                     0x00,0x41,0x22,0x1c,0x00, // 29 )
                     0x14,0x08,0x3e,0x08,0x14, // 2a *
                     0x08,0x08,0x3e,0x08,0x08, // 2b +
                     0x00,0x50,0x30,0x00,0x00, // 2c ,
                     0x08,0x08,0x08,0x08,0x08, // 2d -
                     0x00,0x60,0x60,0x00,0x00, // 2e .
                     0x20,0x10,0x08,0x04,0x02, // 2f /
                     0x3e,0x51,0x49,0x45,0x3e, // 30 0
                     0x00,0x42,0x7f,0x40,0x00, // 31 1
                     0x42,0x61,0x51,0x49,0x46, // 32 2
                     0x21,0x41,0x45,0x4b,0x31, // 33 3
                     0x18,0x14,0x12,0x7f,0x10, // 34 4
                     0x27,0x45,0x45,0x45,0x39, // 35 5
                     0x3c,0x4a,0x49,0x49,0x30, // 36 6
                     0x01,0x71,0x09,0x05,0x03, // 37 7
                     0x36,0x49,0x49,0x49,0x36, // 38 8
                     0x06,0x49,0x49,0x29,0x1e, // 39 9
                     0x00,0x36,0x36,0x00,0x00, // 3a :
                     0x00,0x56,0x36,0x00,0x00, // 3b ;
                     0x08,0x14,0x22,0x41,0x00, // 3c <
                     0x14,0x14,0x14,0x14,0x14, // 3d =
                     0x00,0x41,0x22,0x14,0x08, // 3e >
                     0x02,0x01,0x51,0x09,0x06, // 3f ?
                     0x32,0x49,0x79,0x41,0x3e, // 40 @
                     0x7e,0x11,0x11,0x11,0x7e, // 41 A
                     0x7f,0x49,0x49,0x49,0x36, // 42 B
                     0x3e,0x41,0x41,0x41,0x22, // 43 C
                     0x7f,0x41,0x41,0x22,0x1c, // 44 D
                     0x7f,0x49,0x49,0x49,0x41, // 45 E
                     0x7f,0x09,0x09,0x09,0x01, // 46 F
                     0x3e,0x41,0x49,0x49,0x7a, // 47 G
                     0x7f,0x08,0x08,0x08,0x7f, // 48 H
                     0x00,0x41,0x7f,0x41,0x00, // 49 I
                     0x20,0x40,0x41,0x3f,0x01, // 4a J
                     0x7f,0x08,0x14,0x22,0x41, // 4b K
                     0x7f,0x40,0x40,0x40,0x40, // 4c L
                     0x7f,0x02,0x0c,0x02,0x7f, // 4d M
                     0x7f,0x04,0x08,0x10,0x7f, // 4e N
                     0x3e,0x41,0x41,0x41,0x3e, // 4f O
                     0x7f,0x09,0x09,0x09,0x06, // 50 P
                     0x3e,0x41,0x51,0x21,0x5e, // 51 Q
                     0x7f,0x09,0x19,0x29,0x46, // 52 R
                     0x46,0x49,0x49,0x49,0x31, // 53 S
                     0x01,0x01,0x7f,0x01,0x01, // 54 T
                     0x3f,0x40,0x40,0x40,0x3f, // 55 U
                     0x1f,0x20,0x40,0x20,0x1f, // 56 V
                     0x3f,0x40,0x38,0x40,0x3f, // 57 W
                     0x63,0x14,0x08,0x14,0x63, // 58 X
                     0x07,0x08,0x70,0x08,0x07, // 59 Y
                     0x61,0x51,0x49,0x45,0x43, // 5a Z
                     0x00,0x7f,0x41,0x41,0x00, // 5b [
                     0x02,0x04,0x08,0x10,0x20, // 5c Yen Currency Sign
                     0x00,0x41,0x41,0x7f,0x00, // 5d ]
                     0x04,0x02,0x01,0x02,0x04, // 5e ^
                     0x40,0x40,0x40,0x40,0x40, // 5f _
                     0x00,0x01,0x02,0x04,0x00, // 60 `
                     0x20,0x54,0x54,0x54,0x78, // 61 a
                     0x7f,0x48,0x44,0x44,0x38, // 62 b
                     0x38,0x44,0x44,0x44,0x20, // 63 c
                     0x38,0x44,0x44,0x48,0x7f, // 64 d
                     0x38,0x54,0x54,0x54,0x18, // 65 e
                     0x08,0x7e,0x09,0x01,0x02, // 66 f
                     0x0c,0x52,0x52,0x52,0x3e, // 67 g
                     0x7f,0x08,0x04,0x04,0x78, // 68 h
                     0x00,0x44,0x7d,0x40,0x00, // 69 i
                     0x20,0x40,0x44,0x3d,0x00, // 6a j
                     0x7f,0x10,0x28,0x44,0x00, // 6b k
                     0x00,0x41,0x7f,0x40,0x00, // 6c l
                     0x7c,0x04,0x18,0x04,0x78, // 6d m
                     0x7c,0x08,0x04,0x04,0x78, // 6e n
                     0x38,0x44,0x44,0x44,0x38, // 6f o
                     0x7c,0x14,0x14,0x14,0x08, // 70 p
                     0x08,0x14,0x14,0x18,0x7c, // 71 q
                     0x7c,0x08,0x04,0x04,0x08, // 72 r
                     0x48,0x54,0x54,0x54,0x20, // 73 s
                     0x04,0x3f,0x44,0x40,0x20, // 74 t
                     0x3c,0x40,0x40,0x20,0x7c, // 75 u
                     0x1c,0x20,0x40,0x20,0x1c, // 76 v
                     0x3c,0x40,0x30,0x40,0x3c, // 77 w
                     0x44,0x28,0x10,0x28,0x44, // 78 x
                     0x0c,0x50,0x50,0x50,0x3c, // 79 y
                     0x44,0x64,0x54,0x4c,0x44, // 7a z
                     0x00,0x08,0x36,0x41,0x00, // 7b <
                     0x00,0x00,0x7f,0x00,0x00, // 7c |
                     0x00,0x41,0x36,0x08,0x00, // 7d >
                     0x10,0x08,0x08,0x10,0x08, // 7e Right Arrow    ->
                     0x78,0x46,0x41,0x46,0x78  // 7f Left Arrow   <-
 } ;
// ***************************************************************************** Invio stringa ai 74xx595
// Invio stringa al 74xx595
// ATTENZIONE: PER COLLEGAMENTO RESET E LED AL 595, CAMBIARE "I<4" CON "I<6"
// *****************************************************************************
 void Send_str_595 () {
  unsigned short i, buf;
//
     buf = value_lcd;
      for (i=0; i<mark; i++) {          // 4 o 6!
         data_595 = buf.B0;             // Data 595
          clk_595 =1;                   // Clock 595
           buf >>= 1;
            Delay_us (2);
             clk_595 =0;
      }
       Delay_us(2);           // ATTENZIONE: se il 74HC595 NON  HC, variare il tempo
                              // e cambiare la capacit da 100pF con un valore 
                              // sperimentale.
     //  store_595 = 1;                // Store nuova riga
     ///   Delay_us(2);
      //   store_595 = 0;
 }
// -------------------------------------------------------- Ritardo 2 us
 void Delay_2us () {
    asm nop
 }
// -------------------------------------------------------- INIT LCD
 void initlcd(void){
   _RST = 1;   Send_str_595 ();   // Set _RES HIGH.
    Delay_msec(2);
   _SCE = 0;                     // Enable Chip.
    Send_str_595 ();
     Delay_msec(2);
   _RST = 0;  Send_str_595 ();    // Reset the LCD.
    Delay_msec(100);   // Wait 100ms.
   _RST = 1;  Send_str_595 ();    // Awake LCD from RESET state.
    Delay_msec(2);
//
   writecom(0x21);      // Activate Chip and H=1.
   writecom(0xC2);      // Set LCD Voltage to about 7V.
   writecom(0x13);      // Adjust voltage bias.
   writecom(0x20);      // Horizontal addressing and H=0.
   writecom(0x09);      // Activate all segments.
   delay_ms(100);
   writecom(0x08);      // Blank the Display.
   delay_msec(100);
   writecom(0x0C);      // Display Normal.
   delay_msec(100);
   cursorxy(0,0);      // Cursor Home.
   clearram();
 }

// -------------------------------------------------------- SCRIVE COMANDO
 void writecom(char command_in){
   D_C = 0; Send_str_595 ();           // Select Command register.
    Delay_2us();
     _SCE = 0; Send_str_595 ();           // Select Chip.
      Delay_2us();
       clockdata(command_in);   // Clock in command bits.
        _SCE = 1; Send_str_595 ();           // Deselect Chip.
         Delay_2us();
 }
// -------------------------------------------------------- SCRIVE DATA
 void writedata(char data_in){
   D_C = 1; Send_str_595 ();           // Select Data register.
    Delay_2us();
   _SCE = 0; Send_str_595 ();           // Select Chip.
    Delay_2us();
   clockdata(data_in);      // Clock in data bits.
   _SCE = 1; Send_str_595 ();           // Deselect Chip.
    Delay_2us();
 }
// -------------------------------------------------------- CLOCK DATA
 void clockdata(char bits_in){
   int bitcnt;
      for (bitcnt=8; bitcnt>0; bitcnt--) {
       SCK = 0; Send_str_595 ();
        Delay_2us();
// Set Clock Idle level LOW.
        if ((bits_in&0x80)==0x80){       // PCD8544 clocks in the MSb first.
         SDI=1; Send_str_595 ();
          Delay_2us();
        }
         else{
          SDI=0;Send_str_595 ();
           Delay_2us();
         }
         SCK = 1; Send_str_595 ();      // Data is clocked on the rising edge of SCK.
          Delay_2us();

// Data is clocked on the rising edge of SCK.
          bits_in = bits_in<<1;

// Logical shift data by 1 bit left.
      }
 }
// -------------------------------------------------------- CLEAR LCD
 void clearram(void){
   int ddram;
   cursorxy(0,0);
      // Cursor Home.
   for (ddram=504;ddram>0;ddram--)   writedata(0x00);  // 6*84 = 504 DDRAM addresses.
 }
// -------------------------------------------------------- POSIZIONE CURSORE (X,Y)
 void cursorxy(char x, char y){
   writecom(0x40|(y&0x07));   // Y axis
   writecom(0x80|(x&0x7f));   // X axis
 }
// -------------------------------------------------------- POSIZIONE Colonna
 void Set_Colonna_x(char x){
   writecom(0x80|(x&0x7f));   // X axis
 }
// -------------------------------------------------------- POSIZIONE Pagina
 void Set_Page_y(char y){
   writecom(0x40|(y&0x07));   // Y axis
 }
// --------------------------------------------------------
 void nokia_erase_y(char ynokia) {
  char row;
///
     for(row=0;row<79;row++) {
       cursorxy(row,ynokia);
        putchar(' ');
     }
 }
// --------------------------------------------------------
 void nokia_erase_x(char xnokia) {
  char column;
//
    for (column=0;column!=6;column++){
      cursorxy(xnokia,column);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
    }
 }
// -------------------------------------------------------- DISEGNA COLONNA
 void Draw_line_oriz_3310(unsigned short X1, unsigned short X2, unsigned short posizione) {



 }
// -------------------------------------------------------- SCRIVE CARATTERE
 void putchar(char character){
  int tablept;
  unsigned char count, char_column;
//
     if ((character<0x20)||(character>0x7f)) {return;} // Exit function if character is not found.
       tablept = ((5*character) - 160);

// Point to the columns of the character in the table.
// Draw the columns to print the character.
       for (count=5;count>0;count--) {
         char_column = table[tablept];
          writedata(char_column);
           tablept++;
       }
         writedata(0x00);    // 1 pixel spacing per character.


 }
// -------------------------------------------------------- SCRIVE STRINGA
 void putstr(const char *s){
   while(*s) {putchar(*s++);}
// Points to one ASCII to be written one at a time.
 }
//----------------------------------------------------------------------
//        SCRIVE UNA STRINGA DI CARATTERI        Write_String_KS0713 ("JUMBO elettronica", 5, 28, 5);
//
//  page: da 0 a 5, se page,B7 = 1: scrive in contrasto.
//----------------------------------------------------------------------
//**********************************************************************
 void Write_String(char string[], unsigned char Page, unsigned char colonna) {
  unsigned short i = 0, temp_count, _Data;
  int temp;
//
     cursorxy(colonna, (Page & 0x0F));      // Numero di pagina e colonna
//
      temp_count = 0;
//
        while (string [i] != 0) {
     //  while (string [i] != 0 && i < 4) {
           temp = string [i];
            temp -= 0x20;
             temp *= 5;
//
              while (temp_count <= 4) {
                 if (Page.F7) _Data = ~table[temp];
                  else _Data = table[temp];
                   writedata(_Data);
                    temp_count ++; 
                     temp ++;
              }
//
          if (Page.F7) writedata(0xFF);         // Spazio tra caratteri
           else writedata(0x00);
            i ++;
             temp_count = 0;
        }
 }
//----------------------------------------------------------------------
//        SCRIVE BITMAP SU MEMORIA RAM NOKIA 3310
//----------------------------------------------------------------------
//********************************************************************** OK
 void Write_Bitmap(char bmp) {
//
  unsigned int bitmap_byte=0;
//
    cursorxy(0, 0);
//
    D_C = 1; Send_str_595 ();           // Select Data register.
     Delay_2us();
      _SCE = 0; Send_str_595 ();           // Select Chip.
       Delay_2us();
        do {
         if (bmp == 0) writedata (bmp1 [bitmap_byte]);
          else if (bmp == 1) writedata (JUMBO70x40 [bitmap_byte]);
           else if (bmp == 2) writedata (mikro_bmp [bitmap_byte]);
        } while (++bitmap_byte <= 503);   // 503
           _SCE = 1; Send_str_595 ();           // Deselect Chip.
 }
//----------------------------------------------------------------------  LINEA VERTICALE
//  DISEGNA UNA LINEA VERTICALE TRA I PUNTI Y1 E Y2 (0-47) ALLA COLONNA [0-83]
//----------------------------------------------------------------------
// X1: Riga iniziale linea
// X2: Riga finale linea
// colonna: Colonna dove disegnare la linea
// colore: 1 => scrivi 1; 0 => scrivi 0.
//********************************************************************** OK
 void Draw_line_vert_3310(unsigned char Y1, unsigned char Y2, unsigned char colonna, char colore) {
  unsigned char temp_1, temp_2, temp_count, page_1, page_2, _data;
//
   if (colonna >=84) colonna = 83;
    if (Y1 >= 48) Y1 = 48;
     if (Y2 >= 48) Y2 = 48;
//
   if (Y1 > Y2) {temp_1 = Y2 ; Y2 = Y1; Y1 = temp_1;}   // X1 sempre > di X2
    page_1 = Y1 >> 3;
     temp_1 = page_1;
      page_2 = Y2 >> 3;
       temp_2 = page_2;
      Y1 &= 0x07;
       Y2 &= 0x07;
//  -------------------------------------- Solo quando la pagina 1 e la 2 sono uguali
    if (page_1 == page_2) {
      cursorxy(colonna, page_1);
       if (colore) writedata (Byte_LOW [Y1] & Byte_HIGH [Y2]); // OR con il dato presente in memoria
        else writedata (0x00);
         return;
    }
//  -------------------------------------- Pagine intermedie (0xFF)
     page_1 += 1;
    if (colore) _data = 0xFF ;
     else _data = 0x00 ;
   while (page_1 < page_2) {
      cursorxy(colonna, page_1);
       writedata (_data);
        page_1 ++;
   }
//  --------------------------------------- Pagina Low
      cursorxy(colonna, temp_1);
       if (colore) writedata (Byte_LOW [Y1]); // OR con il dato presente in memoria                                                // Byte_LOW [X1] | Read_Data (0xFF, colonna)
        else writedata (0x00);
//  --------------------------------------- Pagina High
       cursorxy(colonna, temp_2);
        if (colore) writedata (Byte_HIGH [Y2]); // OR con il dato presente in memoria
                                                  // Byte_LOW [X2] | Read_Data (0xFF, colonna)
         else writedata (0x00);
}
// --------------------------------------------------- STAMPA IL BYTE NELLA POSIZIONE INDICATA
void Dec_BCD_Short (unsigned short Value, unsigned short page, unsigned short colonna) {
 unsigned short buffer;
 unsigned short interi, decimi, centesimi;
//
     cursorxy(colonna, page);
//
// --> 3 cifre
          interi = Value / 100 ;                   // unit
           buffer = Value - (interi * 100) ;
            decimi = buffer / 10;                  // decimi
             centesimi = buffer - (decimi * 10) ;
//
       if (page >= 6) return;

         if (interi == 0) putchar(32);  // se interi = 0, non visualizzarlo
          else putchar(interi+48);
           //colonna +=6;
             putchar(decimi+48);
             //colonna +=6;
              putchar(centesimi+48);

 }
// ---------------------------------------------------------------------
// --------------------------------------------------- Da decimale a BCD
// Value: numero tipo "short" da scomporre e visualizzare sul display
// page: Pagina (0-5)
// colonna: colonna (0-83)
// Width: F7= 0: normale, F7= 1: reverse, F6= 0 | F5= 1: X,XXX, F6= 1 | F5= 0: XX,X , F5 = 1 | F6= 0: XXXX
//
// --------------------------------------------------- STAMPA LA WORD NELLA POSIZIONE INDICATA
void Decimale_BCD (unsigned int Value, unsigned short page, unsigned short colonna, unsigned short Width) {
 unsigned int buffer;
 unsigned short interi, decimi, centesimi, millesimi;
         if (Value >= 9999) Value = 9999;
         cursorxy(colonna, page);
// --> 4 cifre
          interi = Value / 1000 ;                   // unit
           buffer = Value - (interi * 1000) ;
            decimi = buffer / 100;                  // decimi
             buffer = buffer - (decimi * 100) ;
              centesimi = buffer / 10;
               millesimi = buffer - (centesimi * 10) ;
//
      if (page > 5) return;
       if (Width.F6) { goto Decimale_BCD_loop; }
        else {
         if (interi == 0 && Width.F5 == 1) putchar(32);
          else putchar(interi+48);
          colonna += 6;
          if (Width.F5 == 0) {
            putchar(',');
             colonna += 3;
          }
        }
 Decimale_BCD_loop:
       putchar(decimi+48);
        colonna += 6;
         putchar(centesimi+48);
          colonna += 6;
          if (Width.F6) {
           putchar(',');
            colonna += 3;
             putchar(millesimi+48);
          }
            else putchar(millesimi+48);

//          putchar(char character)

// --> 3 cifre
     /*   if (Value >= 999) Value = 999;
          interi = Value/100 ;
           buffer = Value - (interi * 100) ;
            decimi = buffer / 10;
             centesimi = buffer - (decimi * 10) ;
//
       if (page >= 9) return;
       Write_Font_KS0713(interi+48, page, colonna, Width);
        Write_Font_KS0713(',', page, colonna + 6, Width);
               Write_Font_KS0713(decimi+48, page, colonna + 9, Width);
          Write_Font_KS0713(centesimi+48, page, colonna + 15, Width);   */
 }
/*

*/
// END